'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.waitForExpect = exports.Simulate = exports.flushPromises = exports.render = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _testUtils = require('react-dom/test-utils');

var _waitForExpect = require('wait-for-expect');

var _waitForExpect2 = _interopRequireDefault(_waitForExpect);

var _queries = require('./queries');

var queries = _interopRequireWildcard(_queries);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function render(ui) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$container = _ref.container,
      container = _ref$container === undefined ? document.createElement('div') : _ref$container;

  _reactDom2.default.render(ui, container);
  var containerHelpers = Object.entries(queries).reduce(function (helpers, _ref2) {
    var key = _ref2[0],
        fn = _ref2[1];

    helpers[key] = fn.bind(null, container);
    return helpers;
  }, {});
  return _extends({
    container,
    unmount: function unmount() {
      return _reactDom2.default.unmountComponentAtNode(container);
    }
  }, containerHelpers);
}

// this returns a new promise and is just a simple way to
// wait until the next tick so resolved promises chains will continue
function flushPromises() {
  return new Promise(function (resolve) {
    return setImmediate(resolve);
  });
}

exports.render = render;
exports.flushPromises = flushPromises;
exports.Simulate = _testUtils.Simulate;
exports.waitForExpect = _waitForExpect2.default;